import logging


class JenkinsVisitor():
    """Provides graph mapping methods to create and execute jenkins jobs"""

    def __init__(self, graph, job_queue):
        self.graph = graph
        self.queue = job_queue

    def createJob(self, project):
        """Creates the jenkins jobs."""

        logging.getLogger(__name__).info("Adding: %s" % (project.name))
        #print("Predecessors: %s" % (self.graph.predecessors(project)))
        #print("upStream: %s" % (project.upStream))
        #print("Successors: %s" % (self.graph.successors(project)))
        #print("downStream: %s" % (project.downStream))
        #for j in self.queue:
        #    if j.name == job.name:
        #        return
        if project not in self.queue:
            self.queue.append(project)

    def map_create(self, project):
        """Called for each project node in the dependency graph, adds jenkins
        job projects to the queue"""

        # Test for a job with build information
        if project.parameters["target_branch"] is None:
            logging.getLogger(__name__).info("Skipping: %s" % (project.name))
            return

        self.createJob(project)
        return
