import logging
from PackageRepository import PackageRepository


class PackageRepositoryFake(PackageRepository):
    def __init__(self):
        self.ready = False
        self.repo = None
        self.build_depends = set()
        self.binaries = set()

    def get_build_dependencies(self, package_name):
        log_str = "get_build_dependencies: %s" % (package_name)
        logging.getLogger(__name__).info(log_str)
        if self.repo is None:
            return set(self.build_depends)
        if package_name not in self.repo:
            return set()
        return set(self.repo[package_name]["build_dependencies"])

    def get_binaries(self, source_name):
        log_str = "get_build_dependencies: %s" % (source_name)
        logging.getLogger(__name__).info(log_str)
        if self.repo is None:
            return set(self.binaries)
        if source_name not in self.repo:
            return set()
        return set(self.repo[source_name]["binaries"])
